# Sample plugin controller
class TransfertController < ApplicationController
  unloadable

  layout 'base'
  before_filter :find_project, :authorize

  helper :sort
  include SortHelper
  helper :issues
 
  def index
    end
  
  def import
  @i=0
  @issue = Array.new
  @issue_old =Array.new
    @file=params[:fichier]
    if @file.size == 0
      flash.now[:error] = l(:notice_error_fichier)
      render :controller => 'transfert', :action => 'index'
    else
      if @file.original_filename.split('.').last != 'csv'
        flash.now[:error] = l(:notice_error_choix_csv)
        render :controller => 'transfert', :action => 'index'
      else
        flash.now[:notice] = l(:notice_ok_choix)
        @nom_court=@file.original_filename.split('.').first
        @test=(@file.read)
        @test.each_line { |ligne|
        	if ligne.split(';').first != "Taches"
            @flottant=(ligne.split(';').last.split(',').first + "." +ligne.split(';').last.split(',').last).to_f
            @day_due =  ligne.split(';')[2].split("-").first
            @day_start = ligne.split(';')[1].split("-").first
            @year_due = "20" + ligne.split(';')[2].split("-").last
            @year_start = "20" + ligne.split(';')[1].split("-").last
            case (ligne.split(';')[1].split("-")[1].gsub('%E9','e').gsub('%FB','u'))
              when "janv.": @month_start = "01"
              when "fevr.": @month_start = "02"
              when "mars":@month_start = "03"
              when "avr.":@month_start = "04"
              when "mai":@month_start = "05"
              when "juin": @month_start = "06"
              when "juil.":@month_start = "07"
              when "aout":@month_start = "08"
              when "sept.":@month_start = "09"
              when "oct.":@month_start = "10"
              when "nov.":@month_start = "11"
              when "dec.":@month_start = "12"
              else @month_start =ligne.split(';')[2].split("-")[1]
            end
            case (ligne.split(';')[2].split("-")[1].gsub('%E9','e').gsub('%FB','u'))
              when "janv.": @month_due = "01"
              when "fevr.": @month_due = "02"
              when "mars":@month_due = "03"
              when "avr.":@month_due = "04"
              when "mai":@month_due = "05"
              when "juin": @month_due = "06"
              when "juil.":@month_due = "07"
              when "aout":@month_due = "08"
              when "sept.":@month_due = "09"
              when "oct.":@month_due = "10"
              when "nov.":@month_due = "11"
              when "dec.":@month_due = "12"
              else @month_due =ligne.split(';')[2].split("-")[1]
            end
            @caract1 = CGI.escape(ligne.split(";").first).gsub('+',' ').gsub('%E9','e').gsub('%27',' ').gsub('%FB','u').gsub('%2B','+').gsub('%28','(')
        		i = Issue.new :project_id => @project.id,
        		:subject => @caract1,
        		:author_id => 1,
        		:description => @caract1,
        		:tracker_id =>1,
            :due_date => @year_due + "-" + @month_due + "-" + @day_due + " 00:00:00",
            :start_date => @year_start + "-" + @month_start + "-" + @day_start + " 00:00:00",
            :estimated_hours => (@flottant*8).to_i
            @tache_red = Issue.find(:all, :conditions =>{:project_id=>i.project_id, :subject =>@caract1})
            if @tache_red == []
              next unless i.save!
              @issue.push(i)
            else
              @tache_red.each do |tache|
                i.id=tache.id
              end
              @issue_old.push(i)
              
            end
        	end
	}
        render :controller => 'transfert',:action =>'import'
      end
    end
  end

private
  def find_project
    @project=Project.find(params[:id])
  end
end
