require 'redmine'

RAILS_DEFAULT_LOGGER.info 'Demarrer transfert Ms Project Redmine'

Redmine::Plugin.register :Ms_Project do
  name 'Ms Project'
  author 'Yoann Perollet'
  description 'Plugin pour transfert de donnee entre Ms Project et Redmine'
  version '0.0.1'
  
  #settings :default => {'list_size' => '5'}, :partial => 'settings/settings'

  # This plugin adds a project module
  # It can be enabled/disabled at project level (Project settings -> Modules)
  project_module :Project_module do
    # This permission has to be explicitly given
    # It will be listed on the permissions screen
    permission :run_transfert, {:transfert => [:index,:import]}
  end

  # A new item is added to the project menu (because Redmine can't add it anywhere else)
  menu :project_menu, "Ms Project", :controller => 'transfert', :action => 'index'
end
